config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root to: 'home#index'
  # Genera las rutas
  resources :employees, except: [:show]
  resources :records
  resources :search
  resources :profiles, only: [:show, :edit, :update]
  resources :documents

  get 'report', to: 'reports#report'
  post 'report', to: 'reports#report'

  get 'export', to: 'reports#export'
  post 'export', to: 'reports#export'

  get 'searchInCalendar', to: 'search#calendar'
  post 'searchInCalendar', to: 'search#calendar'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/record.rb
class Record < ApplicationRecord
  belongs_to :employee

  def self.porEmpleado(id)
    Record.where("employee_id = #{id}")
  end

  def self.reporte(id)
    Record
          .joins(:employee)
          .where("employee_id = #{id}")
          .order(:job_entry)
  end

  def self.to_csv(employee_id, date_range)
    attributes = ['Fecha', 'Entrada', 'Salida', 'Sub total de horas']

    CSV.generate do |csv|
        nombre = all.first
        
        csv << ["Nombre Completo"]
        csv << [nombre ? nombre.employee.nombre + ", " + nombre.employee.apellido : ""]
        csv << []
        csv << attributes
        hrs_mes = 0
        all.each do |record|
            fecha = record.job_entry.strftime("%d-%m-%Y")
            entrada = record.job_entry.strftime("%I:%M:%S %p")
            salida = record.job_exit ? record.job_exit.strftime("%I:%M:%S %p") : "Sigue trabajando"
            horas_diarias = record.daily_hours ? record.daily_hours.to_f.round(2).to_s + " Horas" : "No hay hora"
            csv << [fecha, entrada, salida, horas_diarias]
            hrs_mes = hrs_mes + record.daily_hours.to_f
        end
        csv << []
        if all.length == 1 && !all.first.job_exit
          csv << ["Aún no hay horas acumuladas mensualmente."]
        else
          csv << ["Total de Horas : ", hrs_mes.round(2)]
        end
    end
  end
end

app/controllers/records_controller.rb
class RecordsController < ApplicationController
    layout "publico"
    before_action :set_record, only: [:show, :edit, :update, :destroy]

    def index
    end

    def show
        respond_to do |format|
            format.html
            format.json{render :json => @registro.to_json}
        end
    end

    def new
        @registro = Record.new
    end

    def edit
    end

    def create
        begin
            tipo = record_params['tipo']
            fecha = record_params['fecha']
            codigo_emp = record_params['codigo']

            if tipo == 'entrada'
                #registro = Record.where(job_entry: fecha, employee_id: codigo_emp)
                registro = Record.where("job_entry LIKE '%#{fecha.to_date}%' AND employee_id = #{codigo_emp}")

                if registro.length > 0
                    mensaje = <<END_STR
                    Buen día, #{registro.first.employee.nombre}!!
                    El sistema validó su registro e indica que ya ingresó su entrada a las #{(registro.first.job_entry).strftime("%I:%M:%S %p")} 
                    con la fecha #{(registro.first.job_entry).strftime("%d-%m-%Y")}.
                    No puedes registrarte dos veces en un día.
END_STR
                    raise mensaje
                else
                    @registro = Record.new()
                    @registro.job_entry = fecha
                    @registro.employee_id = codigo_emp
                end
            else
                registro = Record.where("job_exit IS NULL AND employee_id = #{codigo_emp}")
                if registro.length == 0
                    mensaje = <<END_STR
                    No puedes marcar tu salida de trabajo sin antes haber ingresado.
END_STR
                    raise mensaje
                elsif registro.first.job_entry.to_time >= fecha.to_time
                    mensaje = <<END_STR
                    Tu hora de salida no puede ser antes de la hora de entrada.
END_STR
                    raise mensaje
                else
                    @registro = Record.where("job_exit IS NULL AND employee_id = #{codigo_emp}").take
                    @registro.job_exit = fecha
                    fecha_salida = @registro.job_exit.strftime("%Y-%m-%d %H:%M")
                    fecha_entrada = @registro.job_entry.strftime("%Y-%m-%d %H:%M")
                    @registro.daily_hours = (Time.parse(fecha_salida) - Time.parse(fecha_entrada))/3600
                end
            end
    
            respond_to do |format|
                if @registro.save
                    format.html { redirect_to @registro, notice: "El registro de horario se logró de manera exitosa." }
                    format.json { render :show, status: :created, location: @registro }
                else
                    format.html { render :new, status: :unprocessable_entity }
                    format.json { render json: @registro.errors, status: :unprocessable_entity }
                end
            end
        rescue => exception
            @error = exception
            render template: "records/errors.html.erb"
        end
    end

    def update
    end

    def destroy
    end

    def errors
    end

    private
    def record_params
        params.require(:record).permit(:tipo, :fecha, :codigo)
    end

    def set_record
        @registro = Record.find(params[:id])
    end
end

app/views/records/errors.html.erb
<br>
<h2>Mensaje:</h2>
<br>
<h3><%= @error %></h3>
<br>
<%= link_to 'Retroceder', '/records/new', class: "btn btn-danger" %>

app/views/records/index.xls.erb
<?xml version="1.0"?>
<Workbook xmlns="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:o="urn:schemas-microsoft-com:office:office"
  xmlns:x="urn:schemas-microsoft-com:office:excel"
  xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
  xmlns:html="http://www.w3.org/TR/REC-html40">
  <Worksheet ss:Name="Sheet1">
    <Table>
      <Row>
        <Cell><Data ss:Type="String">Empleado</Data></Cell>
        <Cell><Data ss:Type="String">Entrada</Data></Cell>
        <Cell><Data ss:Type="String">Salida</Data></Cell>
        <Cell><Data ss:Type="String">Horas</Data></Cell>
      </Row>
    <% @records.each do |record| %>
      <Row>
        <Cell><Data ss:Type="String"><%= record.employee.nombre %></Data></Cell>
        <Cell><Data ss:Type="String"><%= record.job_entry.strftime("%I:%M:%S %p") %></Data></Cell>
        <Cell><Data ss:Type="String"><%= record.job_exit.strftime("%I:%M:%S %p") %></Data></Cell>
        <Cell><Data ss:Type="Number"><%= record.daily_hours %></Data></Cell>
      </Row>
    <% end %>
    </Table>
  </Worksheet>
</Workbook>

app/views/records/new.html.erb
<div class="container">
  <div class="row">
    <div class="col-md-3"></div>
    <div class="col-md-6">
      <%= form_for :record, url: records_path do |f| %>
        <br><br>
        <div class="card">
          <div class="card-header">
            <h2 class = "text-center">Marcación Entrada / Salida</h2>
          </div>
          <div class="card-body">
            <div class="item form-group">
              <%= f.label :tipo, "Tipo de marcación" %>
              <div class="input-group">
                <%= f.select(:tipo, options_for_select([['Entrada', 'entrada'], ['Salida', 'salida']]), options = {}, html_options = { class: "form-control" }) %>
              </div>
            </div>

            <div class="item form-group">
              <%= f.label :fecha, "Fecha" %>
              <div class="form-group">
                <%= f.datetime_local_field :fecha, {:class=> "form-control"} %>
              </div>
            </div>

            <div class="item form-group">
              <%= f.label :codigo, "Ingresa tu código de Empleado" %>
              <div class="input-group">
                <%= f.text_field :codigo, {:class=> "form-control"} %>
              </div>
            </div>

            <div class="item form-group">
              <%= f.submit "Guardar", :class => "btn btn-success col-md-12"%>
            </div>
          </div>
        </div>
      <% end %>
    
    
    </div>
  </div>
</div>

app/views/records/show.html.erb
<h2 id="notice"><%= notice %></h2>
<%= link_to 'Retroceder', '/records/new', class: "btn btn-primary" %>